<?php

function AddNewPost ($uid, $message) {
	global $redis;
	$postid = $redis->incr('gbl:nextPostId');
	$redis->hmset("post:$postid", "by", $uid, "content", $message,
		"posted_at", time());
	$redis->lpush("uid:$uid:statuses", $postid);
	$friendslist = $redis->smembers("uid:$uid:friendslist");
	foreach ($friendslist as $friend) {
		$redis->lpush("uid:$friend:updates", $postid);
	}
}

function DeletePost ($postid) {
	global $redis;
	$uid = $redis->hget("post:$postid", "by");
	$redis->lrem("uid:$uid:statuses", 0, $postid);
	$friendslist = $redis->smembers("uid:$uid:friendslist");
	foreach ($friendslist as $friend) {
		$redis->lrem("uid:$friend:updates", 0, $postid);
	}
	$redis->del("post:$postid");
}

function GetMyPostUpdates ($uid, $start, $count) {
	global $redis;
	$post_details = array();
	$postIds = $redis->lrange("uid:$uid:updates", $start, $start+
		$count);
	foreach ($posts as $postId) {
		$post_details[$postId] = $redis->hgetall("post:$postId");
	}
	return $post_details;
}

function getUserUpdates ($uid, $page_uid, $start, $count) {
//check whether the $uid is a friend of $page_uid
	global $redis;
	if (!$redis->sismember("uid:$page_uid:friendslist", $uid)) {
		return "Not a friend. Please add as friend to see updates";
	}
	$post_details = array();
	$postIds = $redis->lrange("uid:$page_uid:statuses", $start, $start + $count);
	foreach ($posts as $postId) {
		$post_details[$postId] = $redis->hgetall("post:$postId");
	}
	return $post_details;
}

function AddNewComment ($postId, $comment, $uid) {
	global $redis;
	$commentId = $redis->incr('gbl:nextCommentId');
	$redis->hmset("comment:$commentId", "by", $uid, "content",$comment, "commented_at", time());
	$redis->lpush("post:$postId:comments", $commentId);
}

function EditComment ($commentId, $comment) {
	global $redis;
	$redis->hmset("comment:$commentId", "content", $comment, "edited_at", time());
}

function DeleteComment ($commentId, $postId) {
	global $redis;
	$redis->del("comment:$commentId");
	$redis->lrem("post:$postId:comments", $commentId);
}

function GetComments ($postId, $start, $count) {
	global $redis;
	$comment_details = array();
	$commentIds = $redis->lrange("post:$postId:comments", $start, $start + $count);
	foreach ($commentIds as $commentId) {
		$comment_details[$commentId] = $redis->hgetall("comment:$commentId");
	}
	return $comment_details;
}
?>