<?php
/* This File contains the functions which can be used to implement a comment system using Redis */

function save_comment($post_id, $author, $comment, $parent_id = 0) {
	global $redis;
	$isParent = false;
	if($parent_id === 0) {
		$isParent = false;
	}
	else {
		$isParent = true;
		$redis->hSet("comment:$parent_id", "hasChildren", 1);
	}
	$comment_data = array("comment_id" => $redis->incr("comments:id:next"),
		"parent_id" => $parent_id,
		"author" => $author,
		"text" => $comment,
		"post_id" => $post_id,
		"hasChildren" => 0,
		"time" => time());
	if($isParent) {
		$redis->rPush("post:" . $post_id . ":comments", $comment_data['comment_id']);
	} else {	￼￼
		$redis->rPush("thread:" . $parentId, $comment_data['comment_id']);
	}
	$redis->hMSet("comment:" . $data['id'], $data);
	return $comment_data['comment_id'];
}

function delete_comment ($comment_id) {
	global $redis;
	$has_children = $redis->hmget("comment:$comment_id","hasChildren");
	if($has_children) {
		$comment_list = $redis->lrange("thread:$comment_id", 0, -1);
		foreach($comment_list as $comment) {
			delete_comment($comment);
		}
		$redis->del("thread:$comment_id");
	}
	$redis->del("comment:$comment_id");
}

function get_comments ($post_id) {
	global $redis;
	$comment_data = get_comment_data("post:" . $post_id . ":comments");
	$parsed_comments = process_comment_tree($comment_data);
	return $parsed_comments;
}

function get_comment_data($key) {
	global $redis;
	$comment_list = $redis->lrange($key, 0, -1);
	$comment_data = array();
	foreach($comment_list as $comment) {
		$comment_data[] = $redis->hgetall($comment);
	}	￼￼￼
	return $comment_data;
}

function process_comment_tree ($comments) {
	global $redis;
	$curr = array();
	foreach($comments as $comment) {
		if($comment['hasChildren'] === "1") {
			$data = get_comment_data("thread:" . $comment['comment_id']);
			$curr[$comment['comment_id']] = process_comment_tree($data);
		}
		$curr[$comment['parent_id']][] = $comment;
	}
	return $curr;
}

?>